////////////////////////////////////////////////////////////////////////////////
// Spglib52.h : main header file for the Spglib52.dll
// @Doc

// 20-Jan-2011  Matt: Version for Unicode apps which may call this ANSI DLL
//              LPCxxx  -> const char* 
//              LPxxx   -> char*
//              TCHAR   -> char
//              TBYTE   -> unsigned char
//              CString -> CStringA
//              _T      -> removed

#ifndef _SPGLIB52_H_
#define _SPGLIB52_H_

#ifndef __AFXWIN_H__
   #error include 'stdafx.h' before including this file for PCH
#endif

#include <afxtempl.h>
#ifdef _DEBUG
#include <crtdbg.h>
#endif

// For PG5_xxx version number definitions
#include "VersionNo.h"

// Old definitions for old code
typedef const char *PCSTR;      //@Type PCSTR | Constant char *
typedef char tbool;             //@Type tbool | char
typedef char tiny;              //@Type tiny | char
typedef unsigned char utiny;    //@Type utiny | unsigned char
#define YES 1                   // please use TRUE
#define NO 0                    // please use FALSE
#define FOREVER while(1)        // please use while(1)
#define assertString(s) ASSERT(_tcslen(s) < sizeof(s)) // if this happens, it's too late!

#define FFPTOA_LEN   13
#define MAX_SIZE_VALUE 13

extern HINSTANCE hLibInstance;
extern UINT MsgPG4Ack;         // ID number for acknoledge message

//@Struct Define a structure used to hold info about an app we
// start with ExecApp so that this info can be used again
// later to test if the app is still running
struct _EXECAPPINFO {
    HINSTANCE hInstance;       //@Field The instance value
    HWND hWnd;                 //@Field The main window handle
    PROCESS_INFORMATION pi;    //@Field Information about the app process and primary thread
                               //@iex     typedef struct _PROCESS_INFORMATION { // pi
                               //     HANDLE hProcess;
                               //     HANDLE hThread;
                               //     DWORD dwProcessId;
                               //     DWORD dwThreadId;
                               // } PROCESS_INFORMATION;

};

//@Type EXECAPPINFO   | struct <t _EXECAPPINFO>
//@Type LPEXECAPPINFO | FAR struct <t _EXECAPPINFO> *
typedef struct _EXECAPPINFO EXECAPPINFO, FAR *LPEXECAPPINFO;

//@Struct Define a structure used to exchange data between applications
//@xref <f ExchangeData>
struct _EXCHANGE_INFO {
   HWND hDestWnd;			//@Field Destination window
   HWND hSrcWnd;			//@Field Source window
   const char* lpID;			//@Field Identifier for the message
    UINT nOutCount;		//@Field Size of pOutBuf
    PVOID pOutBuf;			//@Field Data sent to hDestWnd
    UINT nInCount;			//@Field Size of pInBuf
    PVOID pInBuf;			//@Field Data received back from hDestWnd
};
//@Type EXCHANGE_INFO   | struct <t _EXCHANGE_INFO>
//@Type LPEXCHANGE_INFO | struct <t _EXCHANGE_INFO> *
typedef struct _EXCHANGE_INFO EXCHANGE_INFO, *LPEXCHANGE_INFO;

#define EXCHANGE_DATA_SIZE	10*1024

//@msg "MsgDataExchange" | Sent by ExchangeData() to the destination window
//when exchanging data.
// For more information see ExchangeData().<nl><nl>
// wParam: Source window handle<nl>
// lParam: Exchange identifier string (ATOM)
#define MSG_DATA_EXCHANGE "Saia52:DataExchange"

//@msg "MsgDataReady" | Sent by destination window to the source window to
//specify that data exchange has been done.
// For more information see ExchangeData().<nl><nl>
// wParam: Size of data<nl>
// lParam: Exchange identifier string (ATOM)
#define MSG_DATA_READY "Saia52:DataReady"


/*------ Format in which the resources are represented -------*/

#define INTEGER_FORMAT 0
#define BINARY_FORMAT  1
#define HEXA_FORMAT    2
#define FLOAT_FORMAT   3


/*------ PG5 Application IDs ---------------------------------*/
/* These IDs are used as index in the AppRights array       */
/* (see the PG4DATA structure), and as identifier parameter   */
/* in IsProgramAllowedToRun() function (to be completed).     */

#define PG4_APP_SASM        0
#define PG4_APP_SBUGWIN     1
#define PG4_APP_SCONFWIN    2
#define PG4_APP_SEDITWIN    3
#define PG4_APP_SFUP        4
#define PG4_APP_SGRAFWIN    5
#define PG4_APP_SLINK       6
#define PG4_APP_SMAKE       7
#define PG4_APP_SPG4        8		// not used anymore
#define PG4_APP_SPROJMAN    9
#define PG4_APP_SNET        10
#define PG4_APP_SPROF       11
#define PG4_APP_SPROMWIN    12
#define PG4_APP_SQLCNF32    13
#define PG4_APP_SNET_LON	14

#define PG4_MAX_APP         15

//#define PG4_CRC_FILE         "Pgcheck.ini"  /* PG Data file */
//#define PG4_LIMIT_FILE       "Pglimit.ini"  /* PG limitations file */
//#define PG4_INI_FILE         "SPG4.INI"      /* PG initialization file */
#define PG4_RESEL_LOGO_FILE  "Reslogo.bmp"   /* PG reseller logo file */
#define PG4_USER_LOGO_FILE   "Userlogo.bmp"  /* PG user logo file */
#define PG4_GOONLINE_SECTION "GoOnline"      /* GoOnline section */

//@Struct Time and date
struct tagTIME {
    BYTE    weekday;    /*@Field sun - sat (0-6) */
    BYTE    month;      /*@Field jan - dec (1-12) */
    BYTE    day;        /*@Field 1 - 31 */
    BYTE    hour;       /*@Field 0 - 23 */
    BYTE    min;        /*@Field 0 - 59 */
    BYTE    sec;        /*@Field 0 - 59 */
    WORD    year;       /*@Field 1980 - 2099 */
};

//@Type TIME   | struct <f tagTIME>
//@Type LPTIME | FAR struct <f tagTIME> *
typedef struct tagTIME TIME, FAR *LPTIME;


//@Struct link ID_NUMBERS to predefined strings.
struct tagString_ID{
    char* lpString;     //@Field NULL indicates the last element of array.
    int   ID;           //@Field when last indicate the default.
};

//@Type STRING_ID | struct <t tagString_ID>
typedef struct tagString_ID STRING_ID;

#define MAX_NAME  50        /* maximum length for user/reseller names */

//@Type PG4DATA | struct <t tagPG4DATA>
typedef struct tagPG4DATA PG4DATA;

//@Struct Information relative to a PG5 app<nl>
// These information are used to fill fields in the About dlg box
// and Splash window of the app.
struct tagDLG_ABOUT_PARAM {
   HWND   hWndApp;                  /*@Field app window handle */
   const char* lpAppIcon;                /*@Field app icon resource */
   const char* lpProgName;               /*@Field program name */
   const char* lpProgDescription;        /*@Field program description */
   const char* lpCopyright;              /*@Field date inserted in the copyright string */
   const char* lpAuthor;                 /*@Field author name */
   const char* lpVersion;                /*@Field app version */
   FARPROC lpfnMoreInfo;            /*@Field address of "More Info" function */
};

//@Type DLG_ABOUT_PARAM | struct <t tagDLG_ABOUT_PARAM>
typedef struct tagDLG_ABOUT_PARAM DLG_ABOUT_PARAM;

//#include <StatLink.h>
//#include <PG4AboutBox.h>


#if defined(__cplusplus)
extern "C" {
#endif

AFX_EXT_API BOOL  WINAPI WritePrivateProfileInt(const char* AppName, const char* KeyName, int Int, const char* FileName);
AFX_EXT_API char* WINAPI SkipChar(const char*);
AFX_EXT_API char* WINAPI SkipSpace(const char*);
#undef IsCharSpace  // this can also be defined in Shlwapi.h
AFX_EXT_API BOOL WINAPI IsCharSpace(unsigned char AnsiChar);
AFX_EXT_API int WINAPI StringToID(const STRING_ID far *lpConv, const char* lpString);
AFX_EXT_API const char* WINAPI IDToString(const STRING_ID far *lpConv, int ID);
AFX_EXT_API const char* WINAPI DefaultString(const STRING_ID far *lpStringID);
AFX_EXT_API int WINAPI DefaultID(const STRING_ID far *lpStringID);
AFX_EXT_API tbool WINAPI ReadFileLine(int hFile, char* lpStr, int SizeOfStr);
AFX_EXT_API tbool WINAPI ExecApp(HWND hwndParent, const char* pszName, const char* pszParams,
                                 LPEXECAPPINFO pInfo, UINT nCmdShow);
AFX_EXT_API tbool WINAPI IsAppRunning(LPEXECAPPINFO pInfo);
AFX_EXT_API void WINAPI SystemError(HWND hWnd, WORD ErrorID, const char* lpStr, int nInt);
AFX_EXT_API void WINAPI SystemInfo(HWND hWnd, WORD InfoID, const char* lpStr, int nInt);
AFX_EXT_API void WINAPI DllError(UINT nStringID, ...);
AFX_EXT_API void WINAPI LastError(HWND hWnd);

AFX_EXT_API char* WINAPI _fString(WORD ID);
AFX_EXT_API char* WINAPI fSString(WORD ID, char* lpString, int StringLength);

//old but still supported >>>>
AFX_EXT_API char* WINAPI GetPG4AppsDir(char* lpDir);
AFX_EXT_API char* WINAPI GetPG4LocalDir(char* lpDir);
AFX_EXT_API char* WINAPI GetPG4ProjectsDir(char* pszDir);
//<<<<<

AFX_EXT_API BOOL WINAPI SAIAGetUserName(char* lpUserName);
AFX_EXT_API BOOL WINAPI GetResellerName(char* lpResName);
AFX_EXT_API BOOL WINAPI IsDemoPackage();
AFX_EXT_API BOOL WINAPI IsPrintingAllowed();

//#define IsAppAllowedToRun q9367
//#define IsAppAllowedToRunEx q9364
AFX_EXT_API BOOL WINAPI IsAppAllowedToRun(HWND hWnd, int nAppID, const char* lpAppName, BOOL bDisplayError=TRUE);
AFX_EXT_API BOOL WINAPI IsAppAllowedToRunEx(HWND hWnd, const char* pszAppID, const char* pszAppName, BOOL bDisplayError=TRUE);

AFX_EXT_API BOOL WINAPI ShowPG4AboutDlgBox(DLG_ABOUT_PARAM far *lpParam);
AFX_EXT_API UINT WINAPI RegisterPG4AckMessage( void );
AFX_EXT_API LRESULT WINAPI PostMessageAndWaitAck( HWND hDestWnd, UINT msg, HWND hSrcWnd, LPARAM lParam );
AFX_EXT_API void WINAPI PostAckMessage( HWND hWnd, LRESULT lRes );
AFX_EXT_API LRESULT WINAPI ExchangeData(LPEXCHANGE_INFO pInfo);

AFX_EXT_API void WINAPI CrcInit(void);
AFX_EXT_API WORD WINAPI CrcCalc(WORD crc, BYTE FAR *bp, int len);
AFX_EXT_API WORD WINAPI CrcFileCalc(HWND hWnd, const char* lpFile);

AFX_EXT_API tbool WINAPI IsWindowOfClass(HWND hWnd, const char* ClassName);
AFX_EXT_API void WINAPI DestroyWindowsOfClass(HWND hParentWnd, const char* ClassName);
AFX_EXT_API void WINAPI UpdateChildWindows(HWND hParentWnd, const char* ClassName);
AFX_EXT_API HWND WINAPI GetWindowGrandParent(HWND hWnd);
AFX_EXT_API HWND WINAPI IsClassNameStackAtPt(POINT Pt, const char* ClassName);
AFX_EXT_API void WINAPI CenterWnd( HWND hWndToCenter, HWND hWndRef );
AFX_EXT_API tbool WINAPI IsTopMost(HWND hWnd);

// Functions to replace those in ScommDLL
AFX_EXT_API void WINAPI PcdGetCpuTypeSubType(const char* pszPcdVersion, int* pPcdCpu, int* pPcdType, int* pPcdSubType);
AFX_EXT_API DWORD WINAPI PcdGetFwFeaturesEx(const char* pszPcdVersion);

#if defined(__cplusplus)
}
#endif

// New functions
AFX_EXT_API CStringA WINAPI SPGGetPG5BaseRegistryKey();
AFX_EXT_API CStringA WINAPI SPGGetPG5ProfileString(HKEY hBaseKey, const char* lpszSection, 
    const char* lpszEntry, const char* lpszDefault);

AFX_EXT_API UINT WINAPI SPGGetPG5ProfileInt(HKEY hBaseKey, const char* lpszSection, 
    const char* lpszEntry, int nDefault);
AFX_EXT_API BOOL WINAPI SPGSetPG5ProfileInt(HKEY hBaseKey, const char* lpszSection, 
    const char* lpszEntry, UINT nValue);
AFX_EXT_API BOOL WINAPI SPGSetPG5ProfileString(HKEY hBaseKey, const char* lpszSection, 
    const char* lpszEntry, const char* lpszValue);
AFX_EXT_API BOOL WINAPI SPGSetPG5RegistryString(HKEY hBaseKey, const char* pszSection, 
    const char* pszEntry, const char* pszValue);
AFX_EXT_API int WINAPI SPGGetPG5RegistryString(HKEY hBaseKey, const char* pszSection, 
    const char* pszEntry, char* pszValue, int maxLen);

// Original names for above functions
#define GetPG4BaseRegistryKey SPGGetPG5BaseRegistryKey
#define GetPG4ProfileInt SPGGetPG5ProfileInt
#define GetPG4ProfileString SPGGetPG5ProfileString
#define SetPG4ProfileInt SPGSetPG5ProfileInt
#define SetPG4ProfileString SPGSetPG5ProfileString


//*****************************************************************************
// BitMap Manipulation
/*    PortTool v2.2     dibapi.h
 *
 *  ** Win32 Version **
 *
 *  Copyright (C) 1991-1996 Microsoft Corporation. All rights reserved
 *
 *  Header file for Device-Independent Bitmap (DIB) API.  Provides
 *  function prototypes and constants for the following functions:
 *
 *  BitmapToDIB()        - Creates a DIB from a bitmap
 *  ChangeBitmapFormat() - Changes a bitmap to a specified DIB format
 *  ChangeDIBFormat()    - Changes a DIB's BPP and/or compression format
 *  CopyScreenToBitmap() - Copies entire screen to a standard Bitmap
 *  CopyScreenToDIB()    - Copies entire screen to a DIB
 *  CopyWindowToBitmap() - Copies a window to a standard Bitmap
 *  CopyWindowToDIB()    - Copies a window to a DIB
 *  CreateDIBPalette()   - Creates a palette from a DIB
 *  CreateDIB()          - Creates a new DIB
 *  DestroyDIB()         - Deletes DIB when finished using it
 *  DIBError()           - Displays message box with error message
 *  DIBHeight()          - Gets the DIB height
 *  DIBNumColors()       - Calculates number of colors in the DIB's color table
 *  DIBToBitmap()        - Creates a bitmap from a DIB
 *  DIBWidth()           - Gets the DIB width
 *  FindDIBBits()        - Sets pointer to the DIB bits
 *  GetSystemPalette()   - Gets the current palette
 *  LoadDIB()            - Loads a DIB from a file
 *  PaintBitmap()        - Displays standard bitmap in the specified DC
 *  PaintDIB()           - Displays DIB in the specified DC
 *  PalEntriesOnDevice() - Gets the number of palette entries
 *  PaletteSize()        - Calculates the buffer size required by a palette
 *  PrintDIB()           - Prints the specified DIB
 *  PrintScreen()        - Prints the entire screen
 *  PrintWindow()        - Prints all or part of a window
 *  SaveDIB()            - Saves the specified dib in a file
 *
 * See the file DIBAPI.TXT for more information about these functions.
 *
 */

/* Handle to a DIB */
#define HDIB HANDLE

/* Print Area selection */
#define PW_WINDOW        1
#define PW_CLIENT        2

/* Print Options selection */
#define PW_BESTFIT       1
#define PW_STRETCHTOPAGE 2
#define PW_SCALE         3

/* DIB Macros*/

// WIDTHBYTES performs DWORD-aligning of DIB scanlines.  The "bits"
// parameter is the bit count for the scanline (biWidth * biBitCount),
// and this macro returns the number of DWORD-aligned bytes needed
// to hold those bits.

#define WIDTHBYTES(bits)    (((bits) + 31) / 32 * 4)

/* Error constants */
enum {
      ERR_MIN = 0,                     // All error #s >= this value
      ERR_NOT_DIB = 0,                 // Tried to load a file, NOT a DIB!
      ERR_MEMORY,                      // Not enough memory!
      ERR_READ,                        // Error reading file!
      ERR_LOCK,                        // Error on a GlobalLock()!
      ERR_OPEN,                        // Error opening a file!
      ERR_CREATEPAL,                   // Error creating palette.
      ERR_GETDC,                       // Couldn't get a DC.
      ERR_CREATEDDB,                   // Error create a DDB.
      ERR_STRETCHBLT,                  // StretchBlt() returned failure.
      ERR_STRETCHDIBITS,               // StretchDIBits() returned failure.
      ERR_SETDIBITSTODEVICE,           // SetDIBitsToDevice() failed.
      ERR_STARTDOC,                    // Error calling StartDoc().
      ERR_NOGDIMODULE,                 // Couldn't find GDI module in memory.
      ERR_SETABORTPROC,                // Error calling SetAbortProc().
      ERR_STARTPAGE,                   // Error calling StartPage().
      ERR_NEWFRAME,                    // Error calling NEWFRAME escape.
      ERR_ENDPAGE,                     // Error calling EndPage().
      ERR_ENDDOC,                      // Error calling EndDoc().
      ERR_SETDIBITS,                   // Error calling SetDIBits().
      ERR_FILENOTFOUND,                // Error opening file in GetDib()
      ERR_INVALIDHANDLE,               // Invalid Handle
      ERR_DIBFUNCTION,                 // Error on call to DIB function
      ERR_MAX                          // All error #s < this value
     };

/* Function prototypes */

HDIB BitmapToDIB (HBITMAP hBitmap, HPALETTE hPal);
HDIB ChangeBitmapFormat (HBITMAP hBitmap,
                                   WORD     wBitCount,
                                   DWORD    dwCompression,
                                   HPALETTE hPal);
HDIB ChangeDIBFormat (HDIB hDIB, WORD wBitCount,
                                DWORD dwCompression);
//HBITMAP CopyScreenToBitmap (LPRECT);
//HDIB CopyScreenToDIB (LPRECT);
//HBITMAP CopyWindowToBitmap (HWND, WORD);
//HDIB CopyWindowToDIB (HWND, WORD);
HPALETTE CreateDIBPalette (HDIB);
HDIB CreateDIB(DWORD, DWORD, WORD);
WORD DestroyDIB (HDIB);
void DIBError (int ErrNo);
DWORD DIBHeight (char* lpDIB);
WORD DIBNumColors (char* lpDIB);
HBITMAP DIBToBitmap (HDIB hDIB, HPALETTE hPal);
DWORD DIBWidth (char* lpDIB);
char* FindDIBBits (char* lpDIB);
HPALETTE GetSystemPalette (void);
HDIB LoadDIB (char*);
//BOOL PaintBitmap (HDC, LPRECT, HBITMAP, LPRECT, HPALETTE);
//BOOL PaintDIB (HDC, LPRECT, HDIB, LPRECT, HPALETTE);
int PalEntriesOnDevice (HDC hDC);
WORD PaletteSize (char* lpDIB);
//WORD PrintDIB (HDIB, WORD, WORD, WORD, char*);
//WORD PrintScreen (LPRECT, WORD, WORD, WORD, char*);
//WORD PrintWindow (HWND, WORD, WORD, WORD, WORD, char*);
WORD SaveDIB (HDIB, char*);

/************************************************/

//@Class CDIBitmap | Bitmap manipulation
class AFX_EXT_CLASS CDIBitmap {

public:                                 //@Access public members
   CDIBitmap(const CBitmap& cBitmap);  //@Cmember Create a CDIBitmap from a CBitmap object
   virtual ~CDIBitmap();               //@Cmember Destructor

    //@Cmember,menum Compression values for <mf .Save>
   enum compression {
        Rgb = BI_RGB,       //@@emem Normal mode, uncompressed
        Rle4 = BI_RLE4,     //@@emem Run length, 4 bits compression
        Rle8 = BI_RLE8      //@@emem Run length, 8 bits compression
    };

   //@cmember Copy bitmap to a file
   int Save(const CStringA& fileName, int bits = 4, enum compression c = Rgb, HPALETTE hPal = 0);

//private:                            //@Access private members
   HDIB m_hDib;                     //@Cmember handle to DIB
   HPALETTE m_hPal;                 //@Cmember handle to palette
   HBITMAP m_hBitmap;               //@Cmember handle to bitmap


   CDIBitmap(const CDIBitmap&);             //@Cmember prohibited Copy Constructor
   CDIBitmap& operator= (const CDIBitmap&); //@Cmember prohibited Assignement operator
};


//*****************************************************************************
// Version Information

/*@Module Version |
   <c CVersionInfo> defines the access to the version information in the ressource.<nl>It
   will give access to the fixed info and to all the string file information.
*/

#include <winver.h>

//@class Version Information in resource
class AFX_EXT_CLASS CVersionInfo {
public:                 //@access public members
   //@cmember Create a empty instance, use Init() to initialise the object
   CVersionInfo();

   //@cmember free allocated memory
   ~CVersionInfo();

   //@cmember Initialise the object with version info from fileName
   //NOTE If you get a build error here, it's because you have "Use Unicode character set" = True
   BOOL Init(const CStringA& fileName = "");

   //@cmember Return TRUE if object is initialized and OK
   BOOL IsOk();

   //@cmember Return a ref. to pointer to fixed version info
   const VS_FIXEDFILEINFO* GetFixedFileInfo();

   //@cmember Return the string info for a given topic
   CStringA StringFileInfo(const char* lookUp);

   //@cmember return the current language for the topic
   CStringA Language();

private:                //@access private members
   CVersionInfo(const CVersionInfo& other);             //@Cmember  prohibited Copy Constructor
   CVersionInfo& operator=(const CVersionInfo& other);  //@Cmember prohibited Assignement operator

   BYTE *m_buffer;          //@Cmember internal buffer
   DWORD m_HVer;            //@Cmember handle
   DWORD m_translation;     //@Cmember translation
   UINT m_langCode;         //@Cmember language
   BOOL m_isOk;             //@Cmember internal flag

   VS_FIXEDFILEINFO* m_fixedInfo;   //@Cmember fixed information
};

inline BOOL CVersionInfo::IsOk() {
   return m_isOk;
}


#ifndef UNICODE    // MFC classes won't work with Unicode apps, e.g. CWnd* can't be used

// Save/restore window size/position
AFX_EXT_API BOOL WINAPI SaveWindowPlacement(CWnd* pWnd, const char* pszWindowName);
AFX_EXT_API BOOL WINAPI RestoreWindowPlacement(CWnd* pWnd, const char* pszWindowName);
AFX_EXT_API BOOL WINAPI SaveWindowPos(CWnd *pWnd, const char* pszWindowName);
AFX_EXT_API BOOL WINAPI RestoreWindowPos(CWnd *pWnd, const char* pszWindowName);


////////////////////////////////////////////////////////////////
//@Module TRACEWIN |
// TRACEWIN Copyright 1995-1996 Microsoft Systems Journal.
// If this program works, it was written by Paul DiLascia.
// If not, I don't know who wrote it.
//
// TRACEWIN is a development tool that displays MFC TRACE output in
// a window, even if you don't run under the debugger. To use tracewin,
// simply #include this file in your main .cpp file, the one that contains
// your CWinApp-derived app, and call
//
//    MfxTraceInit();
//
// from your app's InitInstance function. You also need the TRACEWIN applet
// itself, which you can download from any MSJ bulletin board. NOTE: since
// TraceWin.h contains code, you should only #include it in once place in
// your app. (Don't #include it in stdafx.h.)
//
// NOTE: I would have defined a static instance to initialize MfxTrace, so
// calling MfxTraceInit would be unecessary, but there's a problem with the
// order of intializations. CFileTrace requires that afxDump be initialized
// first, which can fail to happen if CFileTrace is initialized as a static
// object.
//@end
// Modification history
// 4-1-95:   Created
// 10-12-95: Use WM_COPYDATA instead of atoms. Also note the name of this
//           file is changed to TRACEWIN.H.
// 11-10-95: Added "Keep WIndow on Top" feature and fixed a bug
//           relating to saved window pos.
// 11-15-95: Save/Restore position with CWindowPlacement.
// 12-05-95: Implemented tracer object with "new" instead of static, so
//           it remains around for reporting memory leaks, if any.

#ifdef _WIN32  // TraceWin only used for WIN32

//@Type TRACEWND_CLASSNAME | Class name for TraceWin ("MfxTraceWindow")
#define TRACEWND_CLASSNAME "MfxTraceWindow"

//@Type ID_COPYDATA_TRACEMSG | This ID is sent as COPYDATASRUCT::dwData to identify the WM_COPYDATA
// message as coming from an app using TRACEWIN.
//
#define ID_COPYDATA_TRACEMSG MAKELONG(MAKEWORD('t','w'),MAKEWORD('i','n'))

#ifdef _DEBUG

//////////////////
// CFileTrace looks like a CFile, but "writes" to the trace window
//
class AFX_EXT_CLASS CFileTrace : public CFile {
   CFileTrace()  { }       // private constructor
public:
   virtual void Write(const void* lpBuf, UINT nCount);
   static void Init();
};

#define MfxTraceInit CFileTrace::Init

#else  // Not _DEBUG

#define MfxTraceInit()

#endif // _DEBUG

#else  // Not _WIN32

#define MfxTraceInit()

#endif // _WIN32

#endif
//*****************************************************************************
// CStaticLink Class

//@Class Simple text hyperlink derived from CStringA
//@Base public | CStringA
class AFX_EXT_CLASS CHyperlink : public CStringA {
public:                                 //@Access public members
    //@Cmember Constructor
   CHyperlink(const char* lpLink = NULL) : CStringA(lpLink) { }

    //@Cmember Destructor
   ~CHyperlink() { }

    //@Cmember Assignement operator
   const CHyperlink& operator=(const char* lpsz) {
      CStringA::operator=(lpsz);
      return *this;
   }
    //@Cmember Convert to const char*
   operator const char*() {
      return CStringA::operator const char*();
   }
    //@Cmember Execute the link
   HINSTANCE Navigate();
};


//@Class CStaticLink implements a static control that's a hyperlink
// to any file on your desktop or web. You can use it in dialog boxes
// to create hyperlinks to web sites. When clicked, opens the file/URL
//@Base public | CStatic
class AFX_EXT_CLASS CStaticLink : public CStatic {
public:                                 //@Access public members
   DECLARE_DYNAMIC(CStaticLink)
   //@Cmember Constructor
   CStaticLink(const char* lpText = NULL, BOOL bDeleteOnDestroy=FALSE);
   //@Cmember Destructor
   ~CStaticLink();
   CHyperlink  m_link;      //@Cmember Hyperlink contains URL/filename. If NULL, I will use the window text.
                            // (GetWindowText) to get the target. see <c CHyperlink>
   COLORREF    m_color;     //@Cmember color
   static COLORREF g_colorUnvisited;   //@Cmember Default colors you can change These are global,
                                       // so they're the same for all links.
   static COLORREF g_colorVisited;     //@Cmember Default colors.
   static HCURSOR  g_hCursorLink;      //@Cmember Cursor used when mouse is on a link--you can set, or
                                       // it will default to the standard hand with pointing finger.
                                       // This is global, so it's the same for all links.
protected:                          //@Access protected member
   CFont       m_font;              //@Cmember underline font for text control
   BOOL        m_bDeleteOnDestroy;  //@Cmember delete object when window destroyed?

   virtual void PostNcDestroy();    //@Cmember cleanup

   // message handlers
   DECLARE_MESSAGE_MAP()
   afx_msg LRESULT   OnNcHitTest(CPoint point);
   afx_msg HBRUSH CtlColor(CDC* pDC, UINT nCtlColor);
   afx_msg void   OnLButtonDown(UINT nFlags, CPoint point);
   afx_msg BOOL   OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
};


//*****************************************************************************
// CDIBitmapFile class
//@Module DIBFile |
//<c CDIBitmapFile> manages the drawing of a bitmap file.
//@class manages the drawing of a bitmap file
//@Base public | CObject
class AFX_EXT_CLASS CDIBitmapFile : public CObject
{
public:                    //@access public members
   //@cmember Read the DIB file
   CDIBitmapFile(CStringA strBMPFile, BOOL *bOK);

   //@cmember Free allocated memory
   virtual ~CDIBitmapFile();

#ifdef _DEBUG
   virtual void AssertValid() const;
#endif

   //@cmember Return the width of the bitmap in pixels
   WORD GetWidth();

   //@cmember Return the height of the bitmap in pixels
   WORD GetHeight();

   //@cmember Display the bitmap at a specified location
   void Draw(CDC *pDC, int xDest, int yDest);

   //@cmember Display the bitmap at a specified location
   // and stretch or compress it to fit the dimensions of the destination rectangle
   void Stretch(CDC *pDC, int xDest, int yDest, int cxDest, int cyDest);
   void StretchHalftone(CDC *pDC, int xDest, int yDest, int cxDest, int cyDest);

//private:                                    //@Access private member
   DWORD  GetInfoHeaderSize(BYTE *lpDIB);   //@Cmember get the header
   BYTE  *GetBitsAddr();                    //@Cmember get bits address
   BYTE  *Read(CStringA strBMPFile);         //@Cmember read the bit map

   BYTE  *lpDIB;        //@Cmember pointer to the memory block containing the DIB
   BYTE  *lpDIBBits;    //@Cmember pointer to the bitmap bits within the DIB
};


#define PG4ABOUTBOX 20000

//@class Display the PG5's About dialog box
//@Base public | CDialog
class AFX_EXT_CLASS CPG4AboutBox : public CDialog
{
public:
    CPG4AboutBox(CWnd* pParent = NULL);
    DLG_ABOUT_PARAM m_param;        //@Cmember Info to display <t tagDLG_ABOUT_PARAM>
    enum { IDD = PG4ABOUTBOX };
    virtual BOOL DestroyWindow();
protected:
    virtual void DoDataExchange(CDataExchange* pDX);
    CFont m_font;
    BOOL m_bRegistered;             // PG5 user is registered
    virtual BOOL OnInitDialog();
    afx_msg void OnPaint();
    afx_msg void OnAboutInfo();
    afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
    afx_msg LRESULT OnCommandHelp(WPARAM, LPARAM lParam);
    DECLARE_MESSAGE_MAP()
private:
    CStaticLink m_wndLink;
    CStaticLink m_wndLink2;
    HINSTANCE hInst;
    HICON hIcon;
    CDIBitmapFile *pDib;
};

typedef CArray<int,int> CIntArray;


/////////////////////////////////////////////////////////////////////////////
// CHorzListBox class

//@class manages a listbox with dynamic horizontal scrollbar
class AFX_EXT_CLASS CHorzListBox : public CListBox
{
// Construction
public:                 //@access public members
   //@Cmember Constructor
   CHorzListBox();

   //@Cmember Stops auto updating of horizontal extent
   void LockHExtentUpdate();

   //@Cmember Turns auto updating back on
   void UnlockHExtentUpdate();

   //@Cmember Updates horizontal extent when auto updating has been turned off for some period
   void UpdateHExtent();

// Attributes
protected:                      //@access private member
   BOOL m_bLocked;              //@Cmember flag
   CIntArray m_arrExtents;      //@Cmember array of extens
   int m_nLongestExtent;        //@Cmember size of extens
   int m_nTabStops;             //@Cmember number of tab stops
   int* m_lpTabStops;           //@Cmember array of tab stops

protected:              //@access protected members
   //@Cmember Updates the extent array when a new item is added
   void InsertNewExtent(int nItem, const char* lpszStr);

   //@Cmember Updates the extent array when a new item is added
   void InsertNewExtent(int nItem, const char* lpszStr, CDC* pDC);

   //@Cmember Initializes tab stops
   void InitTabStops();

// Overrides
   // ClassWizard generated virtual function overrides
   //{{AFX_VIRTUAL(CHorzListBox)
   //}}AFX_VIRTUAL

// Implementation
public:                     //@access public member
   virtual ~CHorzListBox(); //@Cmember constructor

   // Generated message map functions
protected:
   //{{AFX_MSG(CHorzListBox)
   //}}AFX_MSG
   afx_msg LRESULT OnAddString(WPARAM wParam, LPARAM lParam);
   afx_msg LRESULT OnInsertString(WPARAM wParam, LPARAM lParam);
   afx_msg LRESULT OnDeleteString(WPARAM wParam, LPARAM lParam);
   afx_msg LRESULT OnSetTabStops(WPARAM wParam, LPARAM lParam);
   DECLARE_MESSAGE_MAP()
};
//#endif //#ifndef UNICODE


/////////////////////////////////////////////////////////////////////////////
// CRegistry class

/*@Module registry |
   <c CRegistry> writes/reads string and int values to/from the registry
*/

//@class Write/read values to/from the registry
class AFX_EXT_CLASS CRegistry
{
public:              //@access public members
   //@Cmember Constructor
   CRegistry();

   //@Cmember  Write a entry string to the specified section of the registry.
   BOOL WriteString(const char* strSection, const char* strEntry, const char* strValue);

   //@Cmember  Write a entry integer to the specified section of the registry.
   BOOL WriteInt(const char* strSection, const char* strEntry, int nValue);

   //@Cmember Retrieve the string associated with an entry within the specified section in the registry
   CStringA GetString(const char* strSection, const char* strEntry, const char* strDefault);

   //@Cmember Retrieve the integer associated with an entry within the specified section in the registry
   UINT GetInt(const char* strSection, const char* strEntry, int nDefault);

   //@Cmember Enumerate the string values within the specified section in the registry
   LONG EnumValue(const char* strSection, DWORD dwIndex, CStringA& strValue, CStringA& strData);

   //@Cmember Remove an entry within the specified section in the registry
   BOOL RemoveEntry(const char* strSection, const char* strEntry);

private:                        //@access private member
   CStringA m_strCompany;        //@Cmember Company name
};

#ifdef UNICODE
  #if defined(_DEBUG)
    #define SAIA_ASSERT ASSERT
    #define SAIA_VERIFY VERIFY
    #define SAIA_TRACE_0(fmt) 
    #define SAIA_TRACE_1(fmt, expr)
    #define SAIA_TRACE0(fmt) 
    #define SAIA_TRACE1(fmt, expr)
  #else
	#define SAIA_ASSERT
    #define SAIA_VERIFY
    #define SAIA_TRACE_0(fmt) 
    #define SAIA_TRACE_1(fmt, expr)
    #define SAIA_TRACE0(fmt) 
    #define SAIA_TRACE1(fmt, expr)
  #endif
	
#endif

#ifndef UNICODE    // MFC classes won't work with Unicode apps

class AFX_EXT_CLASS CStretchDlg {
    static BOOL CALLBACK StaticCalcMinHeightNWidth(HWND hWndItem, CStretchDlg *const lpStretch);
    static BOOL CALLBACK StaticShiftItem(HWND hWndItem, CStretchDlg *const lpStretch);
    HWND    m_hParentWnd;
    HWND    m_hWndItemStretch;
    RECT    m_StrItemRc;
    int     m_dx, m_dy;
    int     m_MinStretchWidth, m_MinStretchHeight; // min values for stretching
    int     m_LastParentWidth, m_LastParentHeight;
    void    CalcMinHeightNWidth(HWND hWndItem);
    BOOL    IsInB(RECT *lpRect);
    BOOL    IsInC(RECT *lpRect);
    void    ShiftItem(HWND hWndItem);

    public:
    CStretchDlg();
    CStretchDlg(HWND _hWnd, int _Item);
    ~CStretchDlg() {};
    BOOL Init(HWND _hWnd, int _Item);
    void StretchItem(int cxClient, int cyClient);
};

// *** SDebug.h ***

/*
@Module Debug | This module provides sevral MACROS and functions to debug the application<nl>
  Those macros and functions can be used by any application compiled in DEBUG or RELEASE
  mode.
@Group MACROS
@Normal <f MYMSG> Display message
@Normal <f SAIA_ASSERT> Replaces ASSERT in release mode
@Normal <f SAIA_VERIFY> Replaces VERIFY in release mode
@Normal <f SAIA_TRACE_0> Replaces TRACE0
@Normal <f SAIA_TRACE_1> Replaces TRACE1
@Normal <f SAIA_TRACE0> Replaces TRACE0
@Normal <f SAIA_TRACE1> Replaces TRACE1
@Group Functions
@Normal <f SaiaDebug> Send debug information with filename and line number to tracewin
@Normal <f SaiaVerbose> Send Text information to specified window
@Normal <f SaiaMessageBox> Display a messagebox
@Normal <f SaiaHexDump> Display binary data in readable form
*/

// Use in the #pragma, to define a message

#define chSTR(x)    #x
#define chSTR2(x)   chSTR(x)
/*
@macro  | MYMSG | Display a message in the 'build' window with file name and line number<nl>This
 allows you to insert a quick reference in the source file and by double-clicking on the build
 window, to reach this point in the proper source file.
@Syntax #pragma MYMSG(this is a comment)
@Parm char* | desc | Message to display in compiler's 'build' window
@ex Usage | #pragma MYMSG(this is a comment) => C:\Test1\Info.cpp(723): this is a comment
*/
#define MYMSG(desc) message(__FILE__ "(" chSTR2(__LINE__) "): " #desc)

/*
@Macro | SAIA_ASSERT | Replacement for ASSERT.
@Syntax SAIA_ASSERT(expr)
@Group Release mode
@Normal If <p expr> evaluates to false, the expression, the filename and the line number is sent
 to tracewin via a call to <f SaiaDebug>. The program then continues execution.
@Group Debug mode
@Normal Uses ASSERT(expr) to pass the problem to the debug runtime (this causes an abort).
*/
#if defined(_DEBUG)
#define SAIA_ASSERT ASSERT
#else
#define SAIA_ASSERT(expr) \
        if (!(expr)) SaiaDebug("SAIA_ASSERT", #expr, __FILE__, __LINE__);
#endif

/*
@Macro | SAIA_VERIFY | Replacement for VERIFY.
@Syntax SAIA_VERIFY(expr)
@Group Release mode
@Normal If <p expr> evaluates to false, the expression, the filename and the line number is sent
 to tracewin via a call to <f SaiaDebug>. The program then continues execution.
@Group Debug mode
@Normal Uses VERIFY(expr) to pass the problem to the debug runtime (this causes an abort).
*/
#if defined(_DEBUG)
#define SAIA_VERIFY VERIFY
#else
#define SAIA_VERIFY(expr) \
        if (!(expr)) SaiaDebug("SAIA_VERIFY", #expr, __FILE__, __LINE__, GetLastError());
#endif

/*
@Macro | SAIA_TRACE_0 | Replacement for TRACE0 with indication of filename and line number
@Syntax SAIA_TRACE_0(fmt)
*/
#define SAIA_TRACE_0(fmt) \
        SaiaVerbose(0, _T("%s(%d): %s") , __FILE__, __LINE__, fmt)

/*
@Macro | SAIA_TRACE_1 | Replacement for TRACE1 with indication of file and line
@Syntax SAIA_TRACE_1(fmt, expr)
*/
#define SAIA_TRACE_1(fmt, expr) \
        SaiaVerbose(0, _T("%s(%d): ") _T(fmt), __FILE__, __LINE__, expr)

/*
@Macro | SAIA_TRACE0 | Replacement for TRACE0
@Syntax SAIA_TRACE0(fmt)
*/
#define SAIA_TRACE0(fmt) \
        SaiaVerbose(0, _T("%s") , fmt)

/*
@Macro | SAIA_TRACE1 | Replacement for TRACE1
@Syntax SAIA_TRACE1(fmt, expr)
*/
#define SAIA_TRACE1(fmt, expr) \
        SaiaVerbose(0, _T(fmt), expr)

#endif //#ifndef UNICODE
// Bit fields for 'dest' parameter

#define V_ERR_MASK      0xF0000000
//@Type V_INF | Message is for information
#define V_INF           0x00000000      // Information
//@Type V_ERR | Message is for errors
#define V_ERR           0x10000000      // Error
//@Type V_WAR | Message is for warnings
#define V_WAR           0x20000000      // Warning

#define V_DST_MASK      0x0F000000
//@Type V_DST_TRACE | Destination is TRACEWIN.EXE (see <f SaiaVerbose>
#define V_DST_TRACE     0x00000000
//@Type V_DST_SAIA | Destination is SPM.EXE (see <f SaiaVerbose>
#define V_DST_SAIA      0x01000000
//@Type V_DST_SCODRV | Destination is SCODRV32.EXE (see <f SaiaVerbose>
#define V_DST_SCODRV    0x02000000

AFX_EXT_API bool WINAPI SaiaDebug(char* name, char* linedesc, char* filename, int lineno);
AFX_EXT_API bool WINAPI SaiaDebug(char* name, char* linedesc, char* filename, int lineno, DWORD errnum);
AFX_EXT_API bool WINAPI SaiaVerbose(int dest, const char* lpszFormat, ...);
AFX_EXT_API bool WINAPI SaiaVerbose(int dest, UINT iFormat, ...);
AFX_EXT_API void WINAPI SaiaMessageBox(const char* lpszFormat, ...);
AFX_EXT_API void WINAPI SaiaMessageBox(UINT iFormat, ...);
AFX_EXT_API bool WINAPI SaiaHexDump(const char* Data, int Len);




//@Type SAIAWND_CLASSNAME | Class name for Project Manager ("Saia52:SpmWClass")
#define SAIAWND_CLASSNAME "Saia52:SpmWClass"

//@Type ID_COPYDATA_SAIAMSG | This ID is sent as COPYDATASRUCT::dwData to identify the WM_COPYDATA from SPM
#define ID_COPYDATA_SAIAMSG MAKELONG(MAKEWORD('s','a'),MAKEWORD('i','a'))


// Molecule functions
typedef ATOM MOLECULE;
AFX_EXT_API CStringA WINAPI GlobalGetMoleculeName(MOLECULE molecule);

// Misc
AFX_EXT_API void WINAPI DisplayPG5VersionInformation(void);
AFX_EXT_API BOOL WINAPI BrowseForFolderDialog(const char* pszTitle, const char* pszPrompt, const char* pszInitialDir,
                                              char* pszReturnedDir, DWORD dwOptions);

#ifndef UNICODE    //matt: CStringArray and CStringList cannot be used by Unicode apps
// ZIP file functions
//AFX_EXT_API BOOL WINAPI Zip(const char* pszInPath, const char* pszZipPath, BOOL bStorePaths, BOOL bRecurseSubdirs, BOOL bSilent);
//AFX_EXT_API BOOL WINAPI Unzip(const char* pszZipPath, const char* pszDestDir, BOOL bSilent);
AFX_EXT_API BOOL WINAPI ZipGetFileList(const char* pszZipPath, CStringList& strFileList, BOOL bSilent);
#endif


////////////////////////////////////////////////////////////////////////////////
// DesktopDocking.h
// Matt Harvey, 27-Sep-06
// Copyright (C) Saia-Burgess Controls AG, 2007

// Desktop docking messages
enum
{
    DESKTOPDOCKMSG_SUBSCRIBE = 1,
    DESKTOPDOCKMSG_UNSUBSCRIBE = 2,
    DESKTOPDOCKMSG_WINDOWPOSCHANGED = 3,
    DESKTOPDOCKMSG_DOCKPOSCHANGED = 4,		// manager -> client
    DESKTOPDOCKMSG_GETPOS = 5,
};

// Desktop Docking Manager docking positions
enum
{
    DESKTOPDOCKPOS_NONE = 1,
    DESKTOPDOCKPOS_LEFT = 2,
    DESKTOPDOCKPOS_RIGHT = 3,
    DESKTOPDOCKPOS_TOP = 4,
    DESKTOPDOCKPOS_BOTTOM = 5
};


////////////////////////////////////////////////////////////////////////////////
// Desktop docking client
// All editors are clients, SPM is the desktop docking manager

class AFX_EXT_CLASS CDesktopDockingClient
{
protected:
    CWnd* m_pWndClient;			// client window
    HWND m_hWndClient;			// client window handle
    HWND m_hWndManager;			// desktop docking manager window handle, e.g. SPM
    UINT m_dockPos;				// manager's docking position, DESKTOPDOCKPOS_xxx
    BOOL m_bWasZoomedOrIconic;	// TRUE to detect client window restore
    BOOL m_bWmMoving;

public:
    // Construction
    CDesktopDockingClient();
    virtual ~CDesktopDockingClient();

    // Docking position, DESKTOPDOCKPOS_xxx
    UINT GetDockPos() { return m_dockPos; }

    // Subscribe/unsubscribe client for desktop docking
    BOOL Subscribe(CWnd* pWndClient);
    void Unsubscribe();
    BOOL IsSubscribed() { return m_pWndClient != NULL; }

    // Registered message from the manager
    static UINT m_DesktopDockingMsg;
    LRESULT OnMsgFromManager(WPARAM wParam, LPARAM lParam);

    // WM_WINDOWPOSCHANGING, client window size/position is changing
    void OnWindowPosChanging(WINDOWPOS* pWindowPos);

    // WM_WINDOWPOSCHANGED, client window size/position changed
    void OnWindowPosChanged(WINDOWPOS* pWindowPos);

    // WM_SYSCOMMAND
    BOOL OnSysCommand(UINT nID, LPARAM lParam);

    // WM_MOVING
    void OnMoving(UINT fwSide, LPRECT pRect);

    // WM_NCHITTEST
    LRESULT OnNcHitTest(CPoint pt, LRESULT ht);

protected:
    void resizeClientToManager();
};


////////////////////////////////////////////////////////////////////////////////
// Desktop docking manager, used by SPM
// All editors are clients, SPM is the desktop docking manager

class AFX_EXT_CLASS CDesktopDockingManager
{
protected:
    CWnd* m_pWndManager;		// desktop manager's main frame window
    HWND m_hWndManager;			// desktop manager's main frame window handle, e.g. SPM
    UINT m_dockPos;				// manager's docking posistion, DESKTOPDOCKPOS_xxx
    CArray<HWND> m_wndArray;	// array of client window handles
    HWND m_hWndTopClient;		// top client window
    BOOL m_bWmMoving;

    // Returns the index of the client window handle, or -1 if not found
    int findClientWndIndex(HWND hWndClient);

    RECT m_rDesktop;
    BOOL processWindowPos(WINDOWPOS* pWindowPos);
    void resizeClients(int x, int y, int cx, int cy);

public:
    // Construction
    CDesktopDockingManager();
    ~CDesktopDockingManager();

    BOOL Initialize(CWnd* pWndManager, int dockPos);
    void Close();

    // Docking position, DESKTOPDOCKPOS_xxx
    void SetDockPos(int dockPos);
    int GetDockPos() { return m_dockPos; }

    // Registered message from the client, from SendMessage()
    static UINT m_DesktopDockingMsg;
    LRESULT OnMsgFromClient(WPARAM wParam, LPARAM lParam);

    // WM_WINDOWPOSCHANGING, desktop docking manager's main window size is changing
    void OnWindowPosChanging(WINDOWPOS* pWindowPos);

    // WM_WINDOWPOSCHANGED, desktop docking manager's main window size changed
    void OnWindowPosChanged(WINDOWPOS* pWindowPos);

    // WM_SETFOCUS, manager has received the focus
    void OnSetFocus();

    // WM_SYSCOMMAND
    BOOL OnSysCommand(UINT nID, LPARAM lParam);

    // WM_MOVING
    void OnMoving(UINT fwSide, LPRECT pRect);

    // WM_SETTINGCHANGE
    void OnSettingChange(UINT uFlags, const char* lpszSection);

    // WM_NCHITTEST
    LRESULT OnNcHitTest(CPoint pt, LRESULT ht);
};


////////////////////////////////////////////////////////////////////////////////
// New functions in Spglib52.hll, see Misc.cpp
// Matt Harvey, 26-Oct-06

AFX_EXT_API CStringA WINAPI SPGGetAppVersionString();
AFX_EXT_API CStringA WINAPI SPGGetParentDir(const char* pszPath);
AFX_EXT_API CStringA WINAPI SPGGetFullPath(const char* pszCurDir, const char* pszPath);
AFX_EXT_API CStringA WINAPI SPGGetRelativePath(const char* pszDir, const char* pszFilePath);
AFX_EXT_API CStringA WINAPI SPGChangeFileExt(const char* pszFileName, const char* pszNewExt);
AFX_EXT_API CStringA WINAPI SPGGetFileName(const char* pszPathName);
AFX_EXT_API CStringA WINAPI SPGGetNextUntitledFileName(const char* pszDir, const char* pszTemplate);
AFX_EXT_API void WINAPI SPGGetFullPath(CStringA& strFullPath, const char* pszCurDir, const char* pszPath);
AFX_EXT_API void WINAPI SPGGetRelativePath(CStringA& strRelPath, const char* pszDir, const char* pszFilePath);
AFX_EXT_API void WINAPI SPGStripTrailingBackslash(CStringA& strPath);
AFX_EXT_API BOOL WINAPI SPGDelete(const char* pszPath, BOOL bMoveToRecycleBin = FALSE);
AFX_EXT_API BOOL WINAPI SPGIsValidPathName(const char* pszPathName, BOOL bAllowWildcards = FALSE);

#if defined(__cplusplus)
extern "C" {
#endif
AFX_EXT_API BOOL WINAPI Zip(const char* pszInPath, const char* pszZipPath, BOOL bStorePaths, BOOL bRecurseSubdirs, BOOL bSilent);
AFX_EXT_API BOOL WINAPI Unzip(const char* pszZipPath, const char* pszDestDir, BOOL bSilent);
AFX_EXT_API HGLOBAL WINAPI ZipGetFileList2(const char* pszZipPath, BOOL bSilent);

AFX_EXT_API int WINAPI SPGGetAppVersionInt();
AFX_EXT_API BOOL WINAPI SPGIsValidFileName(const char* pszFileName, BOOL bAllowExtension);
AFX_EXT_API BOOL WINAPI SPGWritePrivateProfileInt(const char* pszSection, const char* pszEntry, 
    int value, const char* pszFileName);
AFX_EXT_API BOOL WINAPI SPGCreateDir(const char* pszDir);
AFX_EXT_API BOOL WINAPI SPGHasDir(const char* pszPath);
AFX_EXT_API BOOL WINAPI SPGRename(const char* pszOldName, const char* pszNewName);
AFX_EXT_API BOOL WINAPI SPGMove(const char* pszSource, const char* pszDest);
AFX_EXT_API BOOL WINAPI SPGCopy(const char* pszSource, const char* pszDest);
AFX_EXT_API BOOL WINAPI SPGCopyDir(const char* pszSrcDir, const char* pszDestDir);
AFX_EXT_API BOOL WINAPI SPGSetDirReadOnly(const char* pszDir, BOOL bReadOnly, BOOL bRecurseDirs);
AFX_EXT_API BOOL WINAPI SPGSetReadOnly(const char* pszPath, BOOL bReadOnly);
AFX_EXT_API BOOL WINAPI SPGIsReadOnly(const char* pszPath);
AFX_EXT_API int WINAPI SPGTrimRight(char* pszString);
AFX_EXT_API char* WINAPI SPGSkipWhite(char* pszString);
AFX_EXT_API char* WINAPI SPGSkipBlack(char* pszString);
AFX_EXT_API char* SPGInsertString(char* pszString, int offset, const char* pszInsert);
AFX_EXT_API BOOL WINAPI SPGIsOnRemovableDrive(const char* pszPathName);
AFX_EXT_API void WINAPI SPGStripTrailingBackslash(char* pszPath);
AFX_EXT_API int WINAPI SPGGetWindowsVersion();
#define WIN_31  1
#define WIN_95  2
#define WIN_98  3
#define WIN_NT  4   // Windows NT, 2000, Server 2003, XP or Vista (longhorn)
AFX_EXT_API DWORD WINAPI SPGGetSPMVersion();
AFX_EXT_API BYTE WINAPI SPGToUpper(BYTE ch);
AFX_EXT_API int WINAPI SPGSymCmp(const char* psz1, const char* psz2);
AFX_EXT_API BOOL WINAPI SPGReadRegistryString(HKEY hTopKey, const char* pszSubKey,
                                              const char* pszValueName, char* pszString);

inline BOOL SPGFileExists(const char* pszPath)
{
    DWORD dw = ::GetFileAttributesA(pszPath);
    return dw != DWORD(-1) && (dw & FILE_ATTRIBUTE_DIRECTORY) == 0;
}

inline BOOL SPGDirExists(const char* pszDir)
{
    DWORD dw = ::GetFileAttributesA(pszDir);
    return dw != DWORD(-1) && (dw & FILE_ATTRIBUTE_DIRECTORY) != 0;
}


// More desktop docking
AFX_EXT_API BOOL WINAPI DesktopDocking_SizeWindowToManager(HWND hWnd);
AFX_EXT_API void WINAPI DesktopDocking_GetSettings(int& iDockPos, BOOL& bDockDialogBoxes);
AFX_EXT_API void WINAPI SPGCenterWindow(HWND hWnd);

#if defined(__cplusplus)
}
#endif


////////////////////////////////////////////////////////////////////////////////
// Simple tokenizer for strings delimited by a single character
// Matt: 14.11.07 Add HasMoreTokens() so we know when we're at the end

class AFX_EXT_CLASS CSPGTokenizer
{
public:
    CSPGTokenizer();
    const char* GetFirstToken(const char* pszString, char cDelimiter = ';');
    const char* GetNextToken();
    const char* GetRest();
    BOOL HasMoreTokens() { return m_pszNext != NULL; }

protected:
    CStringA m_strString;
    char* m_pszNext;
    char m_cDelimiter;
};


#ifndef UNICODE    //matt: CStringArray and CStringList cannot be used by Unicode apps
// JPE, 11.06.2008
AFX_EXT_API CStringA SPGJoinArray(const CStringArray& strArray, const char* lpszSeparator);
AFX_EXT_API CStringA SPGJoinArray(const CStringList& strList, const char* lpszSeparator);
template<class T> AFX_EXT_API T SPGSkipwhite(T psz);
AFX_EXT_API void SPGSplitComment(const char* string, CStringA& left, CStringA& right);
AFX_EXT_API void SPGSplitStringOnChar(CStringArray& result, const char* string, char separator, int count=-1);
AFX_EXT_API void SPGSplitStringOnChars(CStringArray& result, const char* string, const char* separator, int count=-1);
AFX_EXT_API int SPGFindChar(const char* string, char chFind, int iStart=0);
AFX_EXT_API int SPGFindAnyChar(const char* string, const char* chsFind, int iStart=0);
#endif

////////////////////////////////////////////////////////////////////////////////
// Matt Harvey, 01-Nov-06, see Misc.cpp

AFX_EXT_API CStringA WINAPI SPGGetSPMOptionsFilePath();
AFX_EXT_API CStringA WINAPI SPGGetProjectsDir();
AFX_EXT_API CStringA WINAPI SPGGetLibsDir();
/*replaced by SPGGetLibsDir()
AFX_EXT_API CStringA WINAPI SPGGetStdLibDir();
AFX_EXT_API CStringA WINAPI SPGGetAppLibDir();
AFX_EXT_API CStringA WINAPI SPGGetUsrLibDir();
AFX_EXT_API CStringA WINAPI SPGGetFbLibDir();
AFX_EXT_API CStringA WINAPI SPGGetAdditionalLibDirs();
*/
AFX_EXT_API CStringA WINAPI SPGUnSubstAppPathTags(const char* pszPath);
AFX_EXT_API CStringA WINAPI SPGSubstAppPathTags(const char* pszPath);
AFX_EXT_API CStringA WINAPI SPGUnSubstAppPathTags(const char* pszPath, const char* pszProjectDir, const char* pszCpuDir);
AFX_EXT_API CStringA WINAPI SPGSubstAppPathTags(const char* pszPath, const char* pszProjectDir, const char* pszCpuDir);
AFX_EXT_API CStringA WINAPI SPGGetAppsDir();
AFX_EXT_API CStringA WINAPI SPGGetLocalDir();
AFX_EXT_API CStringA WINAPI SPGGetTemplatesDir();
AFX_EXT_API CStringA WINAPI SPGGetUserDir();
AFX_EXT_API CStringA WINAPI SPGGetProfileString(const char* pszSection, const char* pszEntry,
                                               const char* pszDefault, const char* pszPath);
AFX_EXT_API int WINAPI SPGGetProfileInt(const char* pszSection, const char* pszEntry,
                                        int iDefault, const char* pszPath);
AFX_EXT_API DWORD WINAPI SPGCrc32(const void* pData, UINT nBytes);
AFX_EXT_API DWORD WINAPI SPGCrc32Partial(DWORD crc, const void* pData, UINT nBytes);
AFX_EXT_API CStringA WINAPI SPGGetUserLocalAppDataDir();
AFX_EXT_API CStringA WINAPI SPGGetUserAppDataDir();
AFX_EXT_API CStringA WINAPI SPGGetCommonAppDataDir();
AFX_EXT_API CStringA WINAPI SPGGetPG5BaseRegistryKey();
AFX_EXT_API CStringA WINAPI SPGGetUserDocumentsDir();
AFX_EXT_API CStringA WINAPI SPGGetCommonDocumentsDir();
AFX_EXT_API CStringA WINAPI SPGGetDocsDir();
AFX_EXT_API CStringA WINAPI SPGGetTempDir();

#if defined(__cplusplus)
extern "C" {
#endif

AFX_EXT_API HGLOBAL WINAPI SPGGetProjectLibraries(const char* pszProjPath);
AFX_EXT_API HGLOBAL WINAPI SPGGetInstalledLibraries(BOOL bRemoveDuplicates);
AFX_EXT_API BOOL WINAPI SPGParseLibraryVersion(const char* pszVersion, int* piVersion);
AFX_EXT_API void WINAPI SPGGetLibLanguage(char* pszLang);
AFX_EXT_API void WINAPI SPGGetAppLanguage(char* pszLang);
AFX_EXT_API BOOL WINAPI SPGGetUsableLibLanguage(const char* pszLinPath, char* pszLang);
AFX_EXT_API BOOL WINAPI SPGGetLibHelpFilePath(const char* pszLinPath, char* pszHelpPath);
AFX_EXT_API BOOL WINAPI SPGDisplayLibraryHelp(HWND hWnd, const char* pszLinPath, const char* pszKeyword);
AFX_EXT_API int WINAPI SPGGetSPMOption(const char* pszOptionName, char* pszRetString, int nMaxLen);
AFX_EXT_API int WINAPI SPGGetUserLocalAppDataDir(char* pszDir);
AFX_EXT_API int WINAPI SPGGetUserAppDataDir(char* pszDir);
AFX_EXT_API int WINAPI SPGGetCommonAppDataDir(char* pszDir);
AFX_EXT_API int WINAPI SPGGetSPMOptionsFilePath(char* pszPath);
AFX_EXT_API int WINAPI SPGGetProjectsDir(char* pszDir);
AFX_EXT_API int WINAPI SPGGetLibsDir(char* pszDir);
AFX_EXT_API int WINAPI SPGGetAppsDir(char* pszDir);
AFX_EXT_API int WINAPI SPGGetLocalDir(char* pszDir);
AFX_EXT_API int WINAPI SPGGetTemplatesDir(char* pszDir);
AFX_EXT_API int WINAPI SPGGetUserDir(char* pszDir);
AFX_EXT_API int WINAPI SPGGetUserDocumentsDir(char* pszDir);
AFX_EXT_API int WINAPI SPGGetCommonDocumentsDir(char* pszDir);
AFX_EXT_API int WINAPI SPGGetDocsDir(char* pszDir);
AFX_EXT_API int WINAPI SPGGetPG5BaseRegistryKey(char* pszKey);
AFX_EXT_API BOOL WINAPI SPGWildcardCompare(const char* pszPattern, const char* pszString);
AFX_EXT_API void WINAPI SPGCreateEnvironment();
AFX_EXT_API int WINAPI SPGUnSubstAppPathTags(const char* pszPath, char* pszResult);
AFX_EXT_API int WINAPI SPGSubstAppPathTags(const char* pszPath, char* pszResult);
AFX_EXT_API int WINAPI SPGUnSubstAppPathTagsEx(const char* pszPath, const char* pszProjectDir, const char* pszCpuDir, char* pszResult);
AFX_EXT_API int WINAPI SPGSubstAppPathTagsEx(const char* pszPath, const char* pszProjectDir, const char* pszCpuDir, char* pszResult);
AFX_EXT_API BOOL WINAPI SPGCompareFiles(const char* pszPath1, const char* pszPath2);
AFX_EXT_API BOOL WINAPI SPGCopySettingsFile(const char* pszFileName, BOOL bShared, char* pszOutPath);
AFX_EXT_API BOOL WINAPI SPGNotifyFileSaved(const char* pszDevicePath, const char* pszFilePaths);
AFX_EXT_API BOOL WINAPI SPGDisplayMessage(const char* pszMsg, int msgType);
AFX_EXT_API void WINAPI SPGTRACE(const char* pszText);
AFX_EXT_API void WINAPI SPGGetTempDir(char* pszDir);
AFX_EXT_API int WINAPI SPGGetProgramFilesDir(char* pszDir);

// Library handling
AFX_EXT_API HGLOBAL WINAPI SPGGetConvertableLibraries(const char* pszLibDirs, BOOL bRecurseSubdirs);
AFX_EXT_API void WINAPI SPGStopGetConvertableLibraries();
AFX_EXT_API HGLOBAL WINAPI SPGGetLibraryFiles(const char* pszLibPath, HGLOBAL* phMemErrors);
AFX_EXT_API HGLOBAL WINAPI SPGCheckLibraryID(const char* pszID, const char* pszSaiaLinFname,
                                             const char* pszProjectPath);

// Molecule functions
#define MAXMOLECULESIZE 6800
AFX_EXT_API void WINAPI GlobalDeleteMolecule(MOLECULE molecule);
AFX_EXT_API MOLECULE WINAPI GlobalAddMolecule(const char* pszName);
AFX_EXT_API int WINAPI GlobalGetMoleculeName(MOLECULE molecule, char* pszString, int maxLen);

#if defined(__cplusplus)
}
#endif


////////////////////////////////////////////////////////////////////////////////
// Class for standard INI file access, see IniFile.cpp
// Matt Harvey, 23-Jan-08
// Note: See also SPGGetProfileString()

class AFX_EXT_CLASS CSPGIniFile
{
protected:
    CStringA m_strFileComment;   // comment from first lines of file
    CPtrArray* m_pSections;     // [section] list
    int m_errLine;              // line number of error, 1..n, -1=missing file

    // helpers
    char* skipwhite(char* psz);
    BOOL trimwhite(char* pszStart, char* pszEnd);
    BOOL findSection(const char* pszSection);
    BOOL findSection(int ixSection);
    BOOL findEntry(const char* pszEntry);
    BOOL findEntry(int ixEntry);
    BOOL findEntry(const char* pszSection, const char* pszEntry);
    void addSection(const char* pszSection);
    void addEntry(const char* pszEntry, const char* pszValue);
    void oldLinFileLicence(CStdioFile& f, char* pszString);

    // findXXX() values, saves passing them as parameters
    // findSection
    int m_iFindSectionIndex;
    BYTE* m_pFindSectionMem;
    CPtrArray* m_pFindEntries;
    char* m_pszFindSection;
    // findEntry
    int m_iFindEntryIndex;
    BYTE* m_pFindEntryMem;
    int m_iFindEntryLen;
    char* m_pszFindEntry;
    char* m_pszFindValue;

public:
    BOOL m_bLessStrict;     // set TRUE to prevent some syntax errors aborting

    // Construction
    CSPGIniFile();
    ~CSPGIniFile();

    // File access
    BOOL Read(const char* pszPath);
    BOOL Write(const char* pszPath);
    int GetErrLine() { return m_errLine; }
    BOOL SetFileComment(const char* pszFileComment);
    const char* GetFileComment();

    // Value access
    const char* GetEntryValue(const char* pszSection, const char* pszEntry);
    const char* GetEntryValue(const char* pszSection, const char* pszEntry, const char* pszDefault);
    BOOL SetEntryValue(const char* pszSection, const char* pszEntry, const char* pszValue);

    // Iteration
    int GetNumSections();
    int GetNumEntries(const char* pszSection);
    int GetNumEntries(int ixSection);
    const char* GetSectionName(int ixSection);
    const char* GetEntryName(int ixSection, int ixEntry);
    const char* GetEntryValue(int ixSection, int ixEntry);
    const char* GetEntryValue(int ixSection, int ixEntry, const char* pszDefault);
    const char* GetEntryValue(int ixSection, const char* pszEntry);
    int GetSectionIndex(const char* pszSection);
    int GetEntryIndex(int ixSection, const char* pszEntry);
    int GetEntryIndex(const char* pszSection, const char* pszEntry);

    // Deletion
    BOOL RemoveEntry(const char* pszSection, const char* pszEntry);
    BOOL RemoveSection(const char* pszSection);
    void RemoveAll();
};


#ifndef UNICODE    // MFC classes won't work with Unicode apps
/////////////////////////////////////////////////////////////////////////////
// CSPGResizingDialog dialog

#define ANCHOR_LEFT     0x0000
#define ANCHOR_TOP      0x0000
#define ANCHOR_RIGHT    0x0001
#define ANCHOR_BOTTOM   0x0002
#define RESIZE_HOR      0x0004
#define RESIZE_VER      0x0008
#define RESIZE_BOTH     (RESIZE_HOR | RESIZE_VER)
#define RESIZE_INVALIDATE 0x0010

class AFX_EXT_CLASS CSPGResizingDialog : public CDialog
{
// Construction
public:
    CSPGResizingDialog( UINT nIDTemplate, CWnd* pParentWnd = NULL );
    void SetControlInfo(WORD CtrlId, WORD Anchor);

    BOOL GetRememberPlacement() { return  m_bRememberPlacement; }
    void SetRememberPlacement(BOOL bRemember) { m_bRememberPlacement = bRemember; }
    BOOL GetPlacementRestored() { return m_bPlacementRestored; }
    const char* GetDialogProfileName() { return m_szDlgName; }

// Dialog Data
public:
    // Set TRUE to remember the window's size and postion
    BOOL m_bRememberPlacement;

    // Set m_bDrawGipper if you don't want a Resizing Gripper
    BOOL m_bDrawGripper;

    // set TRUE if the window size/position was restored from the registry
    BOOL m_bPlacementRestored;

    // Set TRUE if using desktop docking
    BOOL m_bUseDesktopDocking;

    // resize horizontal only
    BOOL m_bHorizontalResizeOnly;

private:
    int m_minWidth, m_minHeight;
    int m_old_cx, m_old_cy;
    BOOL m_bSizeChanged;
    CDWordArray m_control_info;
    CRect m_GripperRect;
    char m_szDlgName[50];  // hex ansi nIDTemplate_iRevision, dialog name for registry
    int m_original_y;
    UINT m_nIDTemplate;

protected:
    // update this if the dialog layout/size is changed
    // it prevents an old size/layout being restored
    int m_iRevision;

    // Generated message map functions
    //{{AFX_MSG(CSPGResizingDialog)
    virtual BOOL OnInitDialog();
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg void OnGetMinMaxInfo(MINMAXINFO* pMMI);
    afx_msg void OnDestroy();
    afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
    afx_msg LRESULT OnNcHitTest(CPoint point);
    afx_msg void OnPaint();
    //}}AFX_MSG

    DECLARE_MESSAGE_MAP()
};
#endif //#ifndef UNICODE

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // _SPGLIB52_H_
